﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@

'  Fires when an Item is Selected by sliding left 
#Event: SlideLeftSelected(ItemID As String)
'  Fires when an Item is Selected by sliding right
#Event: SlideRightSelected(ItemID As String)
'  Fires when an Item is clicked
#Event: ItemClick(ItemID As String)
'  Fires when an Item is long Clicked
#Event: ItemLongClick(ItemID As String)


Sub Class_Globals
	Private moCallBack As Object
	Private msBaseEvent As String
	Private moBmp As Bitmap
	Private moCan As Canvas
	Private moSU As StringUtils
	

	Private moBase As Panel 			' activity or containing control
	Private panContainer As Panel 		' container to house all of our controls
	Private scvSettings As ScrollView 	' scrollview for list
	Private moItems As List				' list of ELItem
	Private moFA As Typeface			' class version of Typeface.FONTAWSOME
	Private moIconFont As Typeface 
	Public Const CHK_OFF As Char = Chr(0xF10C)
	Public Const CHK_ON As Char = Chr(0xF192)

	Type ELItem(ID As String, panCont As Panel, oGest As GestureDetector, lblDivider As Label, ItemPanel As ELPanel, SlideLeftPanel As ELSlidePanel, SlideRightPanel As ELSlidePanel, SlidesLeft As Boolean, SlidesRight As Boolean, Checked As Boolean, lblCheckbox As Label)
	Type ELPanel(panItem As Panel, imvIcon As ImageView, lblTitle As Label, lblSubTitle As Label)
	Type ELSlidePanel(panItem As Panel, lblIcon As Label, lblText As Label)
	Type ELItemDragInfo(IsDown As Boolean, IsMoving As Boolean, IsAnimating As Boolean, ID As String, SlidesLeft As Boolean, SlidesRight As Boolean, panItem As Panel, imvIcon As ImageView, StartX As Int, StartY As Int, CurrentX  As Int, CurrentY As Int, MovingLeft As Boolean, OriginalColor As Int, CurrentColor As Int)
	
	Private moDragItem As ELItemDragInfo
	
	' Properties
	Private miTopMar As Int
	Private miBotMar As Int
	Private miPanelTopMar As Int
	Private miPanelBotMar As Int
	Private miLeftMar As Int
	Private miRightMar As Int
	Private miInnerPadding(4) As Int 
	Private mlAnimationSpeed As Long = 250
	Private miScrollviewColor As Int
	Private miPanelColor As Int
	Private miItemHeight As Int
	Private miItemBackColor As Int 
	Private miTitleTextColor As Int
	Private miSubtitleTextColor As Int
	Private mfTitleMaxTextSize As Float
	Private mfSubtitleMaxTextSize As Float
	Private mfTitleHeightPer As Float
	Private miDivHeight As Int
	Private miDivColor As Int
	Private moTitleFont As Typeface
	Private moSubtitleFont As Typeface
	Private mbCheckboxVisible As Boolean 
	Private mfSelectionPercent As Float 
	
	' SlideLeftPanel
	Private miLeftBackColor As Int 
	Private miLeftTextColor As Int 
	Private msLeftText As String 
	Private mcLeftIcon As Char
		
	' SlideRightPanel
	Private miRightBackColor As Int
	Private miRightTextColor As Int
	Private msRightText As String
	Private mcRightIcon As Char
		
		
End Sub

' Initializes the class, call the .AddViewToParent after initializing to site the control.
' <i>Example:</i><code>
'	 Dim foList As EditList
'	 foList.Initialize(Me, "EditList")
'	 foList.AddViewToParent(Panel1, 0, 0, Panel1.Width, Panel1.Height)
'	 foSets.AddItem(...)
'	 foSets.Refresh
'   </code>
Public Sub Initialize(Callback As Object, BaseEvent As String, b4xFontAwesome As Typeface)
	moCallBack = Callback
	If BaseEvent.Trim = "" Then
		msBaseEvent = ""
	Else
		msBaseEvent = BaseEvent & "_"
	End If

	moBmp.InitializeMutable(2dip, 2dip)
	moCan.Initialize2(moBmp)
	moFA = b4xFontAwesome
	
	moItems.Initialize
		
	panContainer.Initialize("panCont")
	scvSettings.Initialize(10)
	
	moDragItem.Initialize
	moDragItem.IsMoving = False 
		
	LoadDefaults
End Sub

'  Adds a EditList to the supplied control with the parameters specified.
Public Sub AddViewToParent(Base As Panel, Left As Int, Top As Int, Width As Int, Height As Int)
	moBase = Base

	moBase.AddView(panContainer, Left, Top, Width, Height)
	panContainer.Color = Colors.Transparent
	scvSettings.Color = miScrollviewColor 
	scvSettings.Panel.Color = miPanelColor

	' add in our controls
	panContainer.AddView(scvSettings, 0, 0, panContainer.Width, panContainer.Height)

	' layout the controls
	LayoutControls
End Sub

Public Sub GetBase As Panel
	Return panContainer
End Sub

'  Returns the underlying scrollview control
Public Sub GetScrollview As ScrollView
	Return scvSettings
End Sub

' Returns the underlying scrollview control's panel
Public Sub GetScrollviewPanel As Panel
	Return scvSettings.Panel
End Sub

'  Resizes and redraws all controls, this method should be called after you have finished setting all desired properties and before modifying any item controls directly.
Public Sub Refresh
	LayoutControls
End Sub

' Sets the title value for the requested item.
Public Sub SetItemTitle(ItemID As String, Title As String)
	Dim poCS As CSBuilder
	SetItemTitle2(ItemID, poCS.Initialize.Append(Title))
End Sub

' Sets the title value for the requested item.
Public Sub SetItemTitle2(ItemID As String, Title As CSBuilder)
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			Dim poIP As ELPanel = poIt.ItemPanel
			poIP.lblTitle.Text = Title 
			Exit
		End If
	Next
End Sub

' Sets the subtitle for the requested item
Public Sub SetItemSubTitle(ItemID As String, SubTitle As String)
	Dim poCS As CSBuilder
	SetItemSubTitle2(ItemID, poCS.Initialize.Append(SubTitle))
End Sub

' Sets the subtitle for the requested item
Public Sub SetItemSubTitle2(ItemID As String, SubTitle As CSBuilder)
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			Dim poIP As ELPanel = poIt.ItemPanel
			poIP.lblSubTitle.Text = SubTitle
			Exit
		End If
	Next
End Sub





'=================================================================================================================
'=================================================================================================================
'=================================================================================================================
'=================================================================================================================
#Region  Item Methods

'  Removes a specific item from the list, <b>it will NOT refresh the remaining items</b> you should call the .Refresh method after you are done removing items.
Public Sub RemoveItem(ItemID As String)
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			moItems.RemoveAt(piIndex)
			poIt.ItemPanel.imvIcon.RemoveView
			poIt.ItemPanel.lblSubTitle.RemoveView
			poIt.ItemPanel.lblTitle.RemoveView
			poIt.ItemPanel.panItem.RemoveAllViews
			poIt.ItemPanel.panItem.RemoveView
			poIt.SlideLeftPanel.lblIcon.RemoveView
			poIt.SlideLeftPanel.lblText.RemoveView
			poIt.SlideLeftPanel.panItem.RemoveAllViews
			poIt.SlideLeftPanel.panItem.RemoveView
			poIt.SlideRightPanel.lblIcon.RemoveView
			poIt.SlideRightPanel.lblText.RemoveView
			poIt.SlideRightPanel.panItem.RemoveAllViews
			poIt.SlideRightPanel.panItem.RemoveView
			poIt.lblCheckbox.RemoveView
			poIt.lblDivider.RemoveView
			poIt.panCont.RemoveAllViews
			poIt.panCont.RemoveView
			Exit
		End If
	Next
End Sub

'  Removes all items from the list, this will refresh the display upon completion.
Public Sub Clear()
	Dim piIndex As Int
	
	For piIndex = moItems.Size - 1 To 0 Step -1
		Dim poIt As ELItem = moItems.Get(piIndex)
		moItems.RemoveAt(piIndex)
		poIt.ItemPanel.imvIcon.RemoveView
		poIt.ItemPanel.lblSubTitle.RemoveView
		poIt.ItemPanel.lblTitle.RemoveView
		poIt.ItemPanel.panItem.RemoveAllViews
		poIt.ItemPanel.panItem.RemoveView
		poIt.SlideLeftPanel.lblIcon.RemoveView
		poIt.SlideLeftPanel.lblText.RemoveView
		poIt.SlideLeftPanel.panItem.RemoveAllViews
		poIt.SlideLeftPanel.panItem.RemoveView
		poIt.SlideRightPanel.lblIcon.RemoveView
		poIt.SlideRightPanel.lblText.RemoveView
		poIt.SlideRightPanel.panItem.RemoveAllViews
		poIt.SlideRightPanel.panItem.RemoveView
		poIt.lblCheckbox.RemoveView
		poIt.lblDivider.RemoveView
		poIt.panCont.RemoveAllViews
		poIt.panCont.RemoveView
	Next
	moDragItem.ID = ""
	moDragItem.IsAnimating = False 
	moDragItem.IsDown = False
	moDragItem.IsMoving = False
	moItems.Clear 
	LayoutControls
End Sub

'  Returns the internal item for the requested ID
Public Sub GetItem(ItemID As String) As ELItem
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			Return poIt
		End If
	Next
	
	Return Null	
End Sub

Public Sub ItemCount As Int
	Return moItems.Size 
End Sub


Public Sub SetCheckboxesVisible(Visible As Boolean)
	ShowCheckBoxes(Visible)
End Sub

Public Sub GetCheckBoxesVisible As Boolean
	Return mbCheckboxVisible
End Sub

Public Sub SetAllChecks(Checked As Boolean)
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		
		poIt.Checked = Checked
		If Checked Then
			poIt.lblCheckbox.Text = CHK_ON
		Else
			poIt.lblCheckbox.Text = CHK_OFF
		End If
		poIt.lblCheckbox.Invalidate
	Next
End Sub

Public Sub SetItemChecked(ItemID As String, Checked As Boolean)
	Dim piIndex As Int 
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			poIt.Checked = Checked
			If Checked Then
				poIt.lblCheckbox.Text = CHK_ON
			Else
				poIt.lblCheckbox.Text = CHK_OFF
			End If
			poIt.lblCheckbox.Invalidate
			Exit					
		End If
	Next
End Sub

Public Sub ItemChecked(ItemID As String) As Boolean
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			Return poIt.Checked
		End If
	Next
	Return False 	
End Sub

'  Will move the item with the requested ID to the top of the scroll list if possible or at least on screen if at bottom of list.
Public Sub EnsureVisible(ItemID As String)
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			EnsureItemVisible(poIt.ItemPanel.panItem)
			Exit 
		End If
	Next
End Sub

Public Sub SetItemSlides(ItemID As String, SlidesLeft As Boolean, SlidesRight As Boolean)
	Dim piIndex As Int
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			poIt.SlidesLeft = SlidesLeft
			poIt.SlidesRight = SlidesRight
			Exit
		End If
	Next
End Sub


' Returns a list of string containing the ItemIDs for all checked items.
Public Sub CheckedItems As List
	Dim poList As List
	Dim piIndex As Int
	
	poList.Initialize
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.Checked Then
			poList.Add(poIt.ID)
		End If
	Next
	
	Return poList
End Sub


Public Sub AddItem(ItemID As String, Title As String, Subtitle As String, Icon As Bitmap, SlidesLeft As Boolean, SlidesRight As Boolean)
	Dim piIndex As Int
	Dim piPanelY As Int 
	Dim piPanWidth As Int 
	Dim piY As Int 
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		If poIt.ID = ItemID Then
			MyLog("EditList - ERROR:  Cannot add duplicate ID (" & ItemID & ") to list.")
			Return 
		End If
	Next
	
	piPanelY = scvSettings.Panel.Height
	piPanWidth = scvSettings.Width 
	
	Dim poNew As ELItem
	poNew.Initialize
	poNew.SlideLeftPanel.Initialize
	poNew.SlideRightPanel.Initialize
	poNew.ID = ItemID
	poNew.SlidesLeft = SlidesLeft
	poNew.SlidesRight = SlidesRight
	poNew.Checked = False 


	' Entire base item container
	poNew.panCont.Initialize("panItemContainer")
	scvSettings.Panel.AddView(poNew.panCont, 0, piPanelY, piPanWidth, miItemHeight + miDivHeight)
	poNew.panCont.Tag = ItemID 

	piY = 0 
	
	' Divider 
	poNew.lblDivider.Initialize("")
	poNew.panCont.AddView(poNew.lblDivider, 0, piY, piPanWidth, miDivHeight)
	If moItems.Size > 0 And miDivHeight > 0 Then
		poNew.lblDivider.Visible = True
		poNew.lblDivider.Color = miDivColor
		piY = piY + miDivHeight
	Else
		poNew.lblDivider.Visible = False 
	End If

	' checkbox for select all 
	poNew.lblCheckbox.Initialize("lblCheckBox")
	poNew.panCont.AddView(poNew.lblCheckbox, 0, piY, miItemHeight, miItemHeight)
	poNew.lblCheckbox.Tag = ItemID
	poNew.lblCheckbox.Visible = False 

	
	' SlideLeft panel
	poNew.SlideLeftPanel.Initialize
	poNew.SlideLeftPanel.panItem.Initialize("")
	poNew.panCont.AddView(poNew.SlideLeftPanel.panItem, 0, piY, piPanWidth, miItemHeight)
	poNew.SlideLeftPanel.panItem.Tag = ItemID 
	poNew.SlideLeftPanel.panItem.Color = miLeftBackColor
	'		icon
	poNew.SlideLeftPanel.lblIcon.Initialize("")
	poNew.SlideLeftPanel.panItem.AddView(poNew.SlideLeftPanel.lblIcon, 0, 0, 10dip, 10dip)
	poNew.SlideLeftPanel.lblIcon.Tag = ItemID 
	'		text
	poNew.SlideLeftPanel.lblText.Initialize("")
	poNew.SlideLeftPanel.panItem.AddView(poNew.SlideLeftPanel.lblText, 11dip, 0, 10dip, 10dip)
	poNew.SlideLeftPanel.lblText.Tag = ItemID

	' SlideRight panel
	poNew.SlideRightPanel.Initialize
	poNew.SlideRightPanel.panItem.Initialize("")
	poNew.panCont.AddView(poNew.SlideRightPanel.panItem, 0, piY, piPanWidth, miItemHeight)
	poNew.SlideRightPanel.panItem.Tag = ItemID
	poNew.SlideRightPanel.panItem.Color = miRightBackColor
	'		icon 
	poNew.SlideRightPanel.lblIcon.Initialize("")
	poNew.SlideRightPanel.panItem.AddView(poNew.SlideRightPanel.lblIcon, 0, 0, 10dip, 10dip)
	poNew.SlideRightPanel.lblIcon.Tag = ItemID
	' 		text 
	poNew.SlideRightPanel.lblText.Initialize("")
	poNew.SlideRightPanel.panItem.AddView(poNew.SlideRightPanel.lblText, 11dip, 0, 10dip, 10dip)
	poNew.SlideRightPanel.lblText.Tag = ItemID
	
	' Item Panel
	poNew.ItemPanel.Initialize
	poNew.ItemPanel.panItem.Initialize("panItem")
	poNew.panCont.AddView(poNew.ItemPanel.panItem, 0, piY, piPanWidth, miItemHeight)
	poNew.ItemPanel.panItem.Tag = ItemID 
	poNew.ItemPanel.panItem.Color = miItemBackColor
	'   wire up gestures for the item container
	poNew.oGest.SetOnGestureListener(poNew.ItemPanel.panItem, "panItem")
	
	'		subtitle
	poNew.ItemPanel.lblSubTitle.Initialize("")
	poNew.ItemPanel.panItem.AddView(poNew.ItemPanel.lblSubTitle, 0, 0, 10dip, 10dip)
	poNew.ItemPanel.lblSubTitle.Text = Subtitle
	poNew.ItemPanel.lblSubTitle.Tag = ItemID
	poNew.ItemPanel.lblSubTitle.Color = Colors.Transparent
	'		title 
	poNew.ItemPanel.lblTitle.Initialize("")
	poNew.ItemPanel.panItem.AddView(poNew.ItemPanel.lblTitle, 0, 0, 10dip, 10dip)
	poNew.ItemPanel.lblTitle.Text = Title 
	poNew.ItemPanel.lblTitle.Tag = ItemID
	poNew.itempanel.lblTitle.Color = Colors.Transparent
	'		icon 
	poNew.ItemPanel.imvIcon.Initialize("")
	poNew.ItemPanel.panItem.AddView(poNew.ItemPanel.imvIcon, 0, 0, 10dip, 10dip)
	poNew.ItemPanel.imvIcon.Tag = ItemID
	poNew.ItemPanel.imvIcon.Gravity = Gravity.FILL
	If Icon <> Null Then 
		If Icon.IsInitialized Then 
			poNew.ItemPanel.imvIcon.SetBackgroundImage(Icon)
		End If
	End If
	
			
	' Lay the items out
	LayoutItem(poNew, piY)
	
	' Add to our list
	moItems.Add(poNew)
End Sub




#End Region


'=================================================================================================================
'=================================================================================================================
'=================================================================================================================
'=================================================================================================================
#Region  Local Event Handlers

Private Sub panItem_onLongPress(X As Float, Y As Float, MotionEvent As Object)
	Dim poSend As Panel = Sender
	Dim psID As String = poSend.Tag 
	If moCallBack <> Null Then
		If SubExists(moCallBack, msBaseEvent & "ItemLongClick") Then
			CallSubDelayed2(moCallBack, msBaseEvent & "ItemLongClick", psID)
		End If
	End If
End Sub

Private Sub panItem_onSingleTapConfirmed(X As Float, Y As Float, MotionEvent As Object)
	Dim poSend As Panel = Sender
	Dim psID As String = poSend.Tag
	
	If mbCheckboxVisible Then
		' if checkboxes showing just toggle the checked state, don't fire the click event
		Dim piIndex As Int
		For piIndex = 0 To moItems.Size - 1
			Dim poIt As ELItem = moItems.Get(piIndex)
			If poIt.ID = psID Then
				PlayDefaultClick
				SetItemChecked(psID, Not(poIt.Checked))
				Exit 
			End If
		Next
	Else
		If moCallBack <> Null Then
			If SubExists(moCallBack, msBaseEvent & "ItemClick") Then
				PlayDefaultClick
				CallSubDelayed2(moCallBack, msBaseEvent & "ItemClick", psID)
			End If
		End If
	End If
End Sub


Private Sub lblCheckBox_Click
	Dim poSend As Label = Sender
	Dim psID As String = poSend.Tag
	
	If mbCheckboxVisible Then
		Dim piIndex As Int
		For piIndex = 0 To moItems.Size - 1
			Dim poIt As ELItem = moItems.Get(piIndex)
			If poIt.ID = psID Then
				SetItemChecked(psID, Not(poIt.Checked))
				Exit
			End If
		Next
	End If
End Sub

Private Sub panItem_onTouch(Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Dim poGest As GestureDetector

	If Not(moDragItem.IsAnimating) Then
		Select Case Action
			Case poGest.ACTION_DOWN
				moDragItem.IsDown = True 
					
			Case poGest.ACTION_UP
				If moDragItem.IsMoving Then
					ReturnToHomePosition
				End If
				moDragItem.IsDown = False
			
			Case poGest.ACTION_MOVE
				If moDragItem.IsMoving Then 
					Return False 
				End If

			Case poGest.ACTION_CANCEL
				If moDragItem.IsMoving Then 
					ReturnToHomePosition
				End If
				moDragItem.IsDown = False
		End Select
	End If 
		
	Return True 
End Sub

Private Sub panItem_onDrag(deltaX As Float, deltaY As Float, MotionEvent As Object)
	If moDragItem.IsAnimating Or Not(moDragItem.IsDown) Or mbCheckboxVisible Then 
		Return 
	End If

	If moDragItem.IsMoving Then
		moDragItem.CurrentX = moDragItem.CurrentX + deltaX
		moDragItem.CurrentY = moDragItem.StartY
		Dim piCurrWidth As Int = Abs(moDragItem.StartX - moDragItem.CurrentX)
		' figure percent of color displacement
		moDragItem.CurrentColor = AlterAlpha(moDragItem.OriginalColor, _
					piCurrWidth, moDragItem.panItem.Width)
		moDragItem.panItem.Color = moDragItem.CurrentColor
		moDragItem.panItem.Left = moDragItem.CurrentX
		moDragItem.IsMoving = True
		moDragItem.IsAnimating = False
		moDragItem.panItem.Invalidate
		If HasImage(moDragItem.imvIcon) Then
			SetOpacity(AlphaPercent(piCurrWidth, moDragItem.panItem.Width), moDragItem.imvIcon)
		End If
		' did we trigger?
		If (Abs(moDragItem.CurrentX - moDragItem.StartX ) / moDragItem.panItem.Width) > mfSelectionPercent Then 
			If moCallBack <> Null Then 
				If moDragItem.MovingLeft Then
					If SubExists(moCallBack, msBaseEvent & "SlideLeftSelected") Then 
						CallSubDelayed2(moCallBack, msBaseEvent & "SlideLeftSelected", moDragItem.ID)
					End If 
				Else
					If SubExists(moCallBack, msBaseEvent & "SlideRightSelected") Then
						CallSubDelayed2(moCallBack, msBaseEvent & "SlideRightSelected", moDragItem.ID)
					End If
				End If
			End If
			ReturnToHomePosition
		Else
			' back to start?
			If moDragItem.MovingLeft Then 
				If moDragItem.CurrentX > moDragItem.StartX Then
					ReturnToHomePosition
				End If
			Else
				If moDragItem.CurrentX < moDragItem.StartX Then
					ReturnToHomePosition
				End If
			End If
		End If
	Else
		If Abs(deltaX) > 10dip Then
			Dim piIndex As Int
			Dim panBase As Panel = Sender
			For piIndex = 0 To moItems.Size - 1
				Dim poItem As ELItem = moItems.Get(piIndex)
				If poItem.ID = panBase.Tag Then
					If Not(poItem.SlidesLeft) And deltaX < 0 Then 
						Return 
					Else
						If Not(poItem.SlidesRight) And deltaX > 0 Then 
							Return 
						End If
					End If
					Dim poItemPan As ELPanel = poItem.ItemPanel
					moDragItem.panItem = poItemPan.panItem
					moDragItem.imvIcon = poItemPan.imvIcon
					moDragItem.ID = poItem.ID
					moDragItem.OriginalColor = miItemBackColor
					moDragItem.CurrentColor = miItemBackColor
					moDragItem.SlidesLeft = poItem.SlidesLeft
					moDragItem.SlidesRight = poItem.SlidesRight
					If deltaX < 0 Then
						moDragItem.MovingLeft = True
						Dim poBack As ELSlidePanel = poItem.SlideRightPanel
						poBack.panItem.SendToBack
						poBack.panItem.Elevation = 0
					Else
						moDragItem.MovingLeft = False
						Dim poBack As ELSlidePanel = poItem.SlideLeftPanel
						poBack.panItem.SendToBack
						poBack.panItem.Elevation = 0
					End If
					moDragItem.StartX = moDragItem.panItem.Left
					moDragItem.StartY = moDragItem.panItem.Top
					moDragItem.CurrentX = moDragItem.CurrentX + deltaX
					moDragItem.CurrentY = moDragItem.StartY
					Dim piCurrWidth As Int = Abs(moDragItem.StartX - moDragItem.CurrentX)
					' figure percent of color displacement
					moDragItem.CurrentColor = AlterAlpha(moDragItem.OriginalColor, _
					piCurrWidth, moDragItem.panItem.Width)
					moDragItem.panItem.Color = moDragItem.CurrentColor
					If HasImage(moDragItem.imvIcon) Then
						SetOpacity(AlphaPercent(piCurrWidth, moDragItem.panItem.Width), moDragItem.imvIcon)
					End If
					moDragItem.panItem.Left = moDragItem.CurrentX
					moDragItem.IsMoving = True
					moDragItem.IsAnimating = False
					moDragItem.panItem.Invalidate
					Exit
				End If
			Next
		End If
	End If
End Sub



#End Region





'============================================================================================================
'============================================================================================================
'============================================================================================================
'============================================================================================================
#Region  Private methods and functions 

Private Sub PlayDefaultClick
	If moCallBack <> Null Then
		Dim am As JavaObject = GetContext.RunMethod("getSystemService", Array("audio"))
		am.RunMethod("playSoundEffect", Array(0))  'FX_KEY_CLICK
	End If
End Sub

Sub GetContext As JavaObject
	Return GetBA.GetField("context")
End Sub

Sub GetBA As JavaObject
	Dim jo As JavaObject
	Dim cls As String = moCallBack
	cls = cls.SubString("class ".Length)
	jo.InitializeStatic(cls)
	Return jo.GetFieldJO("processBA")
End Sub

Private Sub ShowCheckBoxes(Visible As Boolean)
	Dim piIndex As Int
	
	If moDragItem.IsMoving Or moDragItem.IsAnimating Then 
		Return 
	End If
	
	For piIndex = 0 To moItems.Size - 1
		Dim poIt As ELItem = moItems.Get(piIndex)
		
		If Visible Then 
			poIt.lblCheckbox.Visible = True
			If (poIt.panCont.Top + poIt.panCont.Height) >= scvSettings.ScrollPosition And poIt.panCont.Top <= (scvSettings.ScrollPosition + scvSettings.Height) Then 
				poIt.lblCheckbox.Left = -poIt.lblCheckbox.Width 
				poIt.lblCheckbox.SetLayoutAnimated(mlAnimationSpeed, 0, poIt.lblCheckbox.Top, poIt.lblCheckbox.Width, poIt.lblCheckbox.Height)
				poIt.ItemPanel.panItem.SetLayoutAnimated(mlAnimationSpeed, poIt.lblCheckbox.Width + 10dip, poIt.ItemPanel.panItem.Top, poIt.ItemPanel.panItem.Width, poIt.ItemPanel.panItem.Height)
				poIt.SlideLeftPanel.panItem.SetLayoutAnimated(mlAnimationSpeed, poIt.lblCheckbox.Width + 10dip, poIt.SlideLeftPanel.panItem.Top, poIt.SlideLeftPanel.panItem.Width, poIt.SlideLeftPanel.panItem.Height)
				poIt.SlideRightPanel.panItem.SetLayoutAnimated(mlAnimationSpeed, poIt.lblCheckbox.Width + 10dip, poIt.SlideRightPanel.panItem.Top, poIt.SlideRightPanel.panItem.Width, poIt.SlideRightPanel.panItem.Height)
			Else
				poIt.lblCheckbox.Left = 0
				poIt.ItemPanel.panItem.left = poIt.lblCheckbox.Width + 10dip
				poIt.SlideLeftPanel.panItem.Left = poIt.lblCheckbox.Width + 10dip 
				poIt.SlideRightPanel.panItem.Left = poIt.lblCheckbox.Width + 10dip
			End If
		Else
			If (poIt.panCont.Top + poIt.panCont.Height) >= scvSettings.ScrollPosition And poIt.panCont.Top <= (scvSettings.ScrollPosition + scvSettings.Height) Then
				poIt.lblCheckbox.SetVisibleAnimated(mlAnimationSpeed, False)
				poIt.ItemPanel.panItem.SetLayoutAnimated(mlAnimationSpeed, 0, poIt.ItemPanel.panItem.Top, poIt.ItemPanel.panItem.Width, poIt.ItemPanel.panItem.Height)
				poIt.SlideLeftPanel.panItem.SetLayoutAnimated(mlAnimationSpeed, 0, poIt.SlideLeftPanel.panItem.Top, poIt.SlideLeftPanel.panItem.Width, poIt.SlideLeftPanel.panItem.Height)
				poIt.SlideRightPanel.panItem.SetLayoutAnimated(mlAnimationSpeed, 0, poIt.SlideRightPanel.panItem.Top, poIt.SlideRightPanel.panItem.Width, poIt.SlideRightPanel.panItem.Height)
			Else
				poIt.lblCheckbox.Visible = False 
				poIt.ItemPanel.panItem.left = 0
				poIt.SlideLeftPanel.panItem.Left = 0
				poIt.SlideRightPanel.panItem.Left = 0
			End If
		End If
		poIt.panCont.Invalidate
	Next
	moDragItem.IsAnimating = True 
	Sleep(mlAnimationSpeed)
	mbCheckboxVisible = Visible
	moDragItem.IsDown = False 
	moDragItem.IsMoving= False 
	moDragItem.IsAnimating = False 
End Sub

Private Sub ReturnToHomePosition
	moDragItem.IsDown = False
	moDragItem.IsAnimating = True
	moDragItem.panItem.SetColorAnimated(mlAnimationSpeed, moDragItem.CurrentColor, moDragItem.OriginalColor)
	moDragItem.panItem.SetLayoutAnimated(mlAnimationSpeed, 0, moDragItem.panItem.Top, moDragItem.panItem.Width, moDragItem.panItem.Height)
	If HasImage(moDragItem.imvIcon) Then
		moDragItem.imvIcon.Visible = False 
		moDragItem.imvIcon.SetVisibleAnimated(mlAnimationSpeed, True)
	End If
	Sleep(mlAnimationSpeed)
	moDragItem.ID= ""
	moDragItem.IsMoving = False
	moDragItem.IsAnimating = False
End Sub

Private Sub AlterAlpha(OrigColor As Int, CurrentDiff As Int, MaxWidth As Int) As Int
	Dim piCols() As Int
	Dim pdPercent As Double
	piCols = GetARGB(OrigColor)
	pdPercent = AlphaPercent(CurrentDiff, MaxWidth)
	piCols(0) = 255 * (1 - pdPercent)
	Return Colors.ARGB(piCols(0), piCols(1), piCols(2), piCols(3))
End Sub

Private Sub AlphaPercent(CurrentWidth As Int, MaxWidth As Int) As Float
	Return Max(0, Min(1, (CurrentWidth / Max(1, MaxWidth))))
End Sub

Private Sub SetOpacity(alpha As Float, aView As View)
	Dim aReflector As Reflector
	aReflector.Target = aView
	aReflector.RunMethod2("setAlpha", 1 - alpha, "java.lang.float")
End Sub

Private Sub LayoutControls
	Dim piPanelY As Int
	Dim piIndex As Int
	Dim piPanWidth As Int
	Dim piY As Int
	
	scvSettings.SetLayout(miLeftMar, miTopMar, panContainer.Width - miRightMar - miLeftMar, panContainer.Height - miTopMar - miBotMar)
	scvSettings.Panel.Height = 0
	scvSettings.ScrollPosition = 0
	piPanelY = miPanelTopMar
	piPanWidth = scvSettings.Width

	For piIndex = 0 To moItems.Size - 1
		Dim poItem As ELItem = moItems.Get(piIndex)
		poItem.panCont.SetLayout(0, piPanelY, piPanWidth, miItemHeight + miDivHeight)
		
		If piIndex > 0 And miDivHeight > 0 Then
			poItem.lblDivider.Visible = True
			poItem.lblDivider.Color = miDivColor
			poItem.lblDivider.SetLayout(0, 0, piPanWidth, miDivHeight)
			piY = miDivHeight
		Else
			poItem.lblDivider.Visible = False
			piY = 0 
		End If
		
		LayoutItem(poItem, piY)
		piPanelY = piPanelY + poItem.panCont.Height
	Next
	' resize internal scrollview panel
	piPanelY = piPanelY + miPanelBotMar
	scvSettings.Panel.Height = piPanelY
	scvSettings.Invalidate
	panContainer.Invalidate
End Sub

Private Sub LayoutItem(oItem As ELItem, InnerY As Int) 
	Dim piX As Int 
	Dim piY As Int 
	Dim piLeft As Int 
	Dim piTop As Int 
	Dim piFullW As Int 
	Dim piFullH As Int 
	Dim piW As Int
	Dim piH As Int
	Dim piSize As Int 
	
	
	piFullW = oItem.panCont.Width 
	piFullH = oItem.panCont.Height - InnerY

	' checkbox
	piSize = Min(50dip, piFullH)
	oItem.lblCheckbox.SetLayout(0, ((piFullH - piSize) / 2), piSize, piSize)
	oItem.lblCheckbox.Gravity = Gravity.CENTER
	oItem.lblCheckbox.TextColor = miTitleTextColor
	oItem.lblCheckbox.Typeface = moIconFont
	If mbCheckboxVisible Then
		piLeft = oItem.lblCheckbox.Left + oItem.lblCheckbox.Width + 5dip
		oItem.lblCheckbox.Visible = True
	Else
		oItem.lblCheckbox.Visible = False
		piLeft = 0
	End If
	If oItem.Checked Then
		oItem.lblCheckbox.Text = CHK_ON
	Else
		oItem.lblCheckbox.Text = CHK_OFF
	End If
	SetLabelTextSize2(oItem.lblCheckbox, Max(6, mfTitleMaxTextSize - 2.5))
	
	' resize all our base containers
	oItem.ItemPanel.panItem.SetLayout(piLeft, InnerY, piFullW, piFullH)
	oItem.SlideLeftPanel.panItem.SetLayout(piLeft, InnerY, piFullW, piFullH)
	oItem.Sliderightpanel.panItem.SetLayout(piLeft, InnerY, piFullW, piFullH)
	
	oItem.ItemPanel.panItem.BringToFront

	' ============================================================================================
	' Main Panel
	piLeft = miInnerPadding(0)
	piTop = miInnerPadding(1) 
	piW = piFullW - piLeft - miInnerPadding(2)
	piH = piFullH - piTop - miInnerPadding(3)
	'		main panel icon 
	Dim poIcon As ImageView = oItem.ItemPanel.imvIcon 
	poIcon.Left = piLeft 
	poIcon.Top = piTop
	poIcon.Width = piH
	poIcon.Height = piH
	If HasImage(poIcon) Then 
		poIcon.Visible = True
		piLeft = poIcon.Left + poIcon.Width + 5dip
		piW = piFullW - piLeft
	Else
		poIcon.Visible = False 
	End If
	'		main panel title
	Dim lblTitle As Label = oItem.ItemPanel.lblTitle
	Dim lblSubTitle As Label = oItem.ItemPanel.lblSubTitle
	If lblSubTitle.Text.Trim <> "" Then
		lblTitle.SetLayout(piLeft, piTop, piW, piH * mfTitleHeightPer)
	Else
		lblTitle.SetLayout(piLeft, piTop, piW, piH)
	End If
	lblTitle.TextColor = miTitleTextColor
	lblTitle.Color = Colors.Transparent
	lblTitle.Typeface = moTitleFont
	lblTitle.TextColor = miTitleTextColor
	lblTitle.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	SetLabelTextSize2(lblTitle, mfTitleMaxTextSize)
	'		main panel subtitle
	If lblSubTitle.Text.Trim <> "" Then
		lblSubTitle.Visible = True 
		piY = lblTitle.Top + lblTitle.Height
		lblSubTitle.SetLayout(piLeft, piY, piW, piH - piY)
		lblSubTitle.TextColor = miSubtitleTextColor
		lblSubTitle.Color = Colors.Transparent
		lblSubTitle.Typeface = moSubtitleFont
		lblSubTitle.Gravity = Gravity.LEFT + Gravity.TOP
		lblSubTitle.SingleLine = False
		SetLabelTextSize2(lblSubTitle, mfSubtitleMaxTextSize)
	Else
		lblSubTitle.Visible = False 
	End If
	
	' ============================================================================================
	' Slide Left Panel (Right Justified)
	piLeft = miInnerPadding(0)
	piTop = miInnerPadding(1)
	oItem.SlideLeftPanel.panItem.Color = miLeftBackColor
	'		Icon label 
	piSize = Min(50dip, piH)
	piY = piTop + ((piH - piSize) / 2)
	Dim lblIcon As Label = oItem.SlideLeftPanel.lblIcon
	lblIcon.SetLayout(piFullW - miInnerPadding(3) - piSize, piY, piSize, piSize)
	lblIcon.Color = Colors.Transparent
	lblIcon.TextColor = miLeftTextColor
	lblIcon.Typeface = moIconFont
	lblIcon.Text = mcLeftIcon
	SetLabelTextSize2(lblIcon, mfTitleMaxTextSize)
	lblIcon.Gravity = Gravity.CENTER
	'		Text Label 
	Dim lblText As Label = oItem.SlideLeftPanel.lblText
	lblText.SetLayout(piLeft, piTop, lblIcon.Left - piLeft - 10dip, piH)
	lblText.Color = Colors.Transparent
	lblText.TextColor = miLeftTextColor
	lblText.Text = msLeftText
	lblText.Typeface = moTitleFont
	SetLabelTextSize2(lblText, mfTitleMaxTextSize)
	lblText.Gravity = Gravity.RIGHT + Gravity.CENTER_VERTICAL

	' ============================================================================================
	' Slide Right Panel (Left Justified)
	piLeft = miInnerPadding(0)
	piTop = miInnerPadding(1)
	oItem.SlideRightPanel.panItem.Color = miRightBackColor
	'		Icon label
	piSize = Min(50dip, piH)
	piY = piTop + ((piH - piSize) / 2)
	Dim lblIcon As Label = oItem.SlideRightPanel.lblIcon
	lblIcon.SetLayout(piLeft, piY, piSize, piSize)
	lblIcon.Color = Colors.Transparent
	lblIcon.TextColor = miRightTextColor
	lblIcon.Typeface = moIconFont
	lblIcon.Text = mcRightIcon
	SetLabelTextSize2(lblIcon, mfTitleMaxTextSize)
	lblIcon.Gravity = Gravity.CENTER
	'		Text Label
	Dim lblText As Label = oItem.SlideRightPanel.lblText
	piX = lblIcon.Left + lblIcon.Width + 10dip
	lblText.SetLayout(piX, piTop, piW - piX, piH)
	lblText.Color = Colors.Transparent
	lblText.TextColor = miRightTextColor
	lblText.Text = msRightText
	lblText.Typeface = moTitleFont
	SetLabelTextSize2(lblText, mfTitleMaxTextSize)
	lblText.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
End Sub

Private Sub LoadDefaults
	miTopMar = 0
	miBotMar = 0
	miPanelTopMar = 5dip
	miPanelBotMar = 20dip
	miLeftMar = 5dip
	miRightMar = 5dip
	mbCheckboxVisible = False 
	moIconFont = moFA 
	miScrollviewColor = Colors.ARGB(255, 250, 250, 250) ' almost white
	miPanelColor = Colors.Transparent ' no color
	miItemHeight = 50dip
	miDivHeight = 3dip
	miDivColor = Colors.ARGB(255, 188, 188, 188)
	moTitleFont = Typeface.DEFAULT
	moSubtitleFont = Typeface.DEFAULT
	miTitleTextColor = Colors.Black
	miSubtitleTextColor = Colors.DarkGray
	mfTitleMaxTextSize = 40
	mfSubtitleMaxTextSize = 18
	mfTitleHeightPer = 0.50
	miItemBackColor = Colors.ARGB(255, 250, 250, 250) ' almost white
	miInnerPadding(0) = 2dip
	miInnerPadding(1) = 2dip
	miInnerPadding(2) = 2dip
	miInnerPadding(3) = 2dip
	mfSelectionPercent = 0.80
		
	miLeftBackColor = Colors.ARGB(255, 255, 0, 0)
	miLeftTextColor = Colors.ARGB(255, 255, 255, 255)
	msLeftText = "DELETE"
	mcLeftIcon = Chr(0xF00D)
	
	miRightBackColor = Colors.ARGB(255, 63, 225, 0)
	miRightTextColor = Colors.ARGB(255, 255, 255, 255)
	msRightText = "SELECT"
	mcRightIcon = Chr(0xF00C)
End Sub

Private Sub HasImage(oImgView As ImageView) As Boolean
	Dim poBmp As Bitmap
	Try
		poBmp = oImgView.Bitmap
		If poBmp.IsInitialized Then
			Return True
		Else
			Return False
		End If
	Catch
		Return False
	End Try
End Sub

Private Sub EnsureItemVisible(oCtl As View)
	Dim piNewTop As Int
	Dim poPan As Panel
	
	poPan = oCtl.Parent
	If poPan <> Null Then
		If poPan.IsInitialized Then
			piNewTop = poPan.Top
		End If
	End If
	scvSettings.ScrollPosition = piNewTop
End Sub


Private Sub MyLog(Text As String)	'ignore
	LogColor(Text, Colors.Magenta)
End Sub

Private Sub SetLabelTextSize2(oLbl As Label, MaxPointSize As Float)
	Dim multipleLines As Boolean = oLbl.Text.Contains(CRLF)
	Dim size As Float
	Dim r As Reflector
	Dim piPadding() As Int
	
	piPadding = oLbl.Padding
	
	r.Target = oLbl
	r.RunMethod4("setPadding", Array As Object(0,0,0,0), Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))
	r.RunMethod4("setIncludeFontPadding", Array As Object(False), Array As String("java.lang.boolean"))

	For size = 4 To MaxPointSize
		If CheckLblTextSize(oLbl, size, multipleLines) Then Exit
	Next
	size = size - 0.5
	' put the padding back
	oLbl.Padding = piPadding
	If CheckLblTextSize(oLbl, size, multipleLines) Then size = size - 1.5
	oLbl.TextSize = size
End Sub

'returns true if the size is too large
Private Sub CheckLblTextSize(oLbl As Label, size As Float, MultipleLines As Boolean) As Boolean
	oLbl.TextSize = size
	If MultipleLines Then
		Return moSU.MeasureMultilineTextHeight(oLbl, oLbl.Text) >  oLbl.Height
	Else
		Return moCan.MeasureStringWidth(oLbl.Text, oLbl.Typeface, size) > oLbl.Width Or _
			moSU.MeasureMultilineTextHeight(oLbl, oLbl.Text) > oLbl.Height
	End If
End Sub


' Returns an array of Int that describes the color passed in.<b />
' (0) = Alpha value, (1) = Red, (2) = Green, (3) = Blue
Private Sub GetARGB(Color As Int) As Int()
	Dim res(4) As Int
	res(0) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)
	res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
	res(2) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
	res(3) = Bit.And(Color, 0xff)
	Return res
End Sub

#End Region	



'============================================================================================================
'============================================================================================================
'============================================================================================================
'============================================================================================================
#Region  Public Properties

' Gets or sets the top margin for the scrollview itself.
Public Sub getTopMargin As Int
	Return miTopMar
End Sub
Public Sub setTopMargin(Value As Int)
	miTopMar = Value
End Sub

' Gets or sets the bottom margin for the scrollview itself.
Public Sub getBottomMargin As Int
	Return miBotMar
End Sub
Public Sub setBottomMargin(Value As Int)
	miBotMar = Value
End Sub

' Gets or sets the top margin for the inner scrollview panel.
Public Sub getPanelTopMargin As Int
	Return miPanelTopMar
End Sub
Public Sub setPanelTopMargin(Value As Int)
	miPanelTopMar = Value
End Sub

' Gets or sets the bottom margin for the inner scrollview panel.  Note that this value will be increased to (scrollview-height - itemheight) if less than that value.
Public Sub getPanelBottomMargin As Int
	Return miPanelBotMar
End Sub
Public Sub setPanelBottomMargin(Value As Int)
	miPanelBotMar = Value
End Sub

' Gets or sets the left margin for the scrollview itself
Public Sub getLeftMargin As Int
	Return miLeftMar
End Sub
Public Sub setLeftMargin(Value As Int)
	miLeftMar = Value
End Sub

' Gets or sets the right margin for the scrollview itself
Public Sub getRightMargin As Int
	Return miRightMar
End Sub
Public Sub setRightMargin(Value As Int)
	miRightMar = Value
End Sub

' Gets or sets the background color for the scrollview panel.
Public Sub getScrollviewColor As Int
	Return miScrollviewColor
End Sub
Public Sub setScrollviewColor(Value As Int)
	miScrollviewColor = Value
	scvSettings.Color = Value
End Sub

' Gets or sets the inner panel background color
Public Sub getPanelBackgroundColor As Int
	Return miPanelColor
End Sub
Public Sub setPanelBackgroundColor(Value As Int)
	miPanelColor = Value
	scvSettings.Panel.Color = Value
End Sub

' Gets or sets the background color for the Item panel.
Public Sub getItemBackColor As Int
	Return miItemBackColor
End Sub
Public Sub setItemBackColor(Value As Int)
	miItemBackColor = Value
End Sub

' Returns and Int() containing the padding around the inside of each item (LEFT, TOP, RIGHT, BOTTOM)
Public Sub GetInnerPadding As Object
	Return miInnerPadding
End Sub 

' Sets the padding around the inside of the items (LEFT, TOP, RIGHT, BOTTOM)
Public Sub SetInnerPadding(Padding() As Object)
	If Padding.Length = 4 Then 
		miInnerPadding(0) = Padding(0) ' LEFT 
		miInnerPadding(1) = Padding(1)	' TOP
		miInnerPadding(2) = Padding(2)	' RIGHT
		miInnerPadding(3) = Padding(3)	' BOTTOM
	End If
End Sub

' Gets or sets the auto-slide speed and speed for show/hide checkboxes animation
Public Sub getAnimationSpeed As Long
	Return mlAnimationSpeed
End Sub
Public Sub setAnimationSpeed(Value As Long)
	mlAnimationSpeed = Value 
End Sub
	
' Gets or sets the height of each item 
Public Sub getItemHeight As Int 
	Return miItemHeight
End Sub
Public Sub setItemHeight(Value As Int)
	miItemHeight = Value 
End Sub

' Gets or sets the text color for each item's title text
Public Sub getTitleTextColor As Int
	Return miTitleTextColor
End Sub
Public Sub setTitleTextColor(Value As Int)
	miTitleTextColor = Value 
End Sub

' Gets or sets the text for for each item's subtitle text
Public Sub getSubtitleTextColor As Int 
	Return miSubtitleTextColor
End Sub
Public Sub setSubtitleTextColor(Value As Int)
	miSubtitleTextColor = Value 
End Sub

' Gets or sets the maximum point sized used for each item's title text
Public Sub getTitleMaxTextSize As Float
	Return mfTitleMaxTextSize
End Sub
Public Sub setTitleMaxTextSize(Value As Float)
	mfTitleMaxTextSize = Value 
End Sub

' Gets or sets the maximum point sized used for each item's subtitle text
Public Sub getSubTitleMaxTextSize As Float
	Return mfSubtitleMaxTextSize
End Sub
Public Sub setSubTitleMaxTextSize(Value As Float)
	mfSubtitleMaxTextSize = Value 
End Sub

' Gets or sets the percent of each item's height that will be used for the Title text (1.0 = 100%)
' (remaining percentage is height of subtitle line)
Public Sub getTitleHeightPercentage As Float
	Return mfTitleHeightPer
End Sub
Public Sub setTitleHeightPercentage(Percentage As Float)
	mfTitleHeightPer = Max(0, Min(1.0, Percentage))
End Sub

' Gets or sets the height of each divider line between each item
Public Sub getDividerHeight As Int
	Return miDivHeight
End Sub
Public Sub setDividerHeight(Value As Int)
	miDivHeight = Value 
End Sub

' Gets or sets the color used for each item's divider
Public Sub getDividerColor As Int
	Return miDivColor
End Sub
Public Sub setDividerColor(Value As Int)
	miDivColor = Value 
End Sub

' Gets or sets the font used to display each item's title text
Public Sub getTitleFont As Typeface
	Return moTitleFont
End Sub
Public Sub setTitleFont(Font As Typeface)
	moTitleFont = Font 
End Sub

' Gets or sets the font used to display each item's Subtitle text
Public Sub getSubtitleFont As Typeface
	Return moSubtitleFont
End Sub
Public Sub setSubtitleFont(Font As Typeface)
	moSubtitleFont = Font 
End Sub

' Gets or sets the percentage of 'slide' necessary to trigger slide left/right selection event (1.0 = 100%, minimum is 5%)
Public Sub getSelectionPercentage As Float 
	Return mfSelectionPercent
End Sub
Public Sub setSelectionPercentage(Percent As Float)
	mfSelectionPercent = Max(0.05, Min(1.0, Percent))
End Sub


' Gets or sets the text display for slide left items.  You should refresh after changing this.
Public Sub getSlideLeftText As String
	Return msLeftText
End Sub
Public Sub setSlideLeftText(Value As String)
	msLeftText = Value 
End Sub

' Gets or sets the text display for slide Right items.  You should refresh after changing this.
Public Sub getSlideRightText As String
	Return msRightText
End Sub
Public Sub setSlideRightText(Value As String)
	msRightText = Value 
End Sub

' Gets or sets the icon chracter to be displayed right of the slide left text.  Uses the FontAwsome font.
Public Sub getSlideLeftIconChar As Char
	Return mcLeftIcon
End Sub
Public Sub setSlideLeftIconChar(Value As Char)
	mcLeftIcon = Value 
End Sub

' Gets or sets the icon chracter to be displayed left of the slide right text.  Uses the FontAwsome font.
Public Sub getSlideRightIconChar As Char
	Return mcRightIcon
End Sub
Public Sub setSlideRightIconChar(Value As Char)
	mcRightIcon = Value 
End Sub


#End Region

	
	
	
	
	
	



